vexcombo = {}
vexcombo.combobar = {}
vexcombo.combopoints = 0
vexcombo.infight = false
vexcombo.energytype = "ENERGY"
vexcombo.maxwidth = 0
vexcombo.maxenergy = 100
vexcombo.maxenergy_prev = 100
vexcombo.currentenergy = 100
vexcombo.currentenergy_prev = 100
vexcombo.markers = {nil}
vexcombo.maxcps = 5
vexcombo.currentcps = 0
vexcombo.currentcps_prev = 0
vexcombo.show = false

SLASH_VEXCOMBO1 = "/vexcombo"
function SlashCmdList.VEXCOMBO(msg, editbox)
	if 		msg == "print" then vexcombo_print_parameters()
	elseif 		msg == "test1" then
		if vexcombo.show then 	vexcombo.show=false	vexcombo.markers[1][1]:Hide() print("test false")
		else 					vexcombo.show=true	vexcombo.markers[1][1]:Show() print("test true") end
	elseif 		msg == "test2" then
		if vexcombo.show then 	vexcombo.show=false	vexcombo.markers[2][1]:Hide() print("test false")
		else 					vexcombo.show=true	vexcombo.markers[2][1]:Show() print("test true") end
	elseif 		msg == "test3" then
		if vexcombo.show then 	vexcombo.show=false	vexcombo.markers[3][1]:Hide() print("test false")
		else 					vexcombo.show=true	vexcombo.markers[3][1]:Show() print("test true") end
	elseif 		msg == "test4" then
		if vexcombo.show then 	vexcombo.show=false	vexcombo.markers[4][1]:Hide() print("test false")
		else 					vexcombo.show=true	vexcombo.markers[4][1]:Show() print("test true") end
	elseif 	msg == "defaults" then print("|CFFFF7D0AVex Combo|r - defaults loaded") vexcombo_loaddefaults(true)
	else print("|CFFFF7D0AVex Combo|r - cmd not found")
	end
end

function vexcombo_onEvent(self, event, arg1, arg2, ...)
	if		event == "PLAYER_LOGIN" 		then vexcombo_initialize(false)
	elseif	event == "PLAYER_ENTER_COMBAT"	then vexcombo.infight=true vexcombo_showEnergybars()
	elseif	event == "PLAYER_LEAVE_COMBAT"	then vexcombo.infight=false vexcombo_showEnergybars()
	elseif	event == "UNIT_DISPLAYPOWER"	then
		vexcombo_setEnergyType()
		vexcombo_showEnergybars()
		vexcombo_changeEnergy(true)
	end
end

function vexcombo_setEnergyType()
	vexcombo.energytype = select(2, UnitPowerType("player"))
end

function vexcombo_onUpdate()
	if UnitPower("player") ~= vexcombo.currentenergy then vexcombo_changeEnergy() end
	
	if GetComboPoints("player") ~= vexcombo.currentcps then vexcombo_changeCps() end
end

function vexcombo_initialize(refresh)
	if not(refresh) then
		print("|CFFFF7D0AVex Combo|r started")
		vexcombo_loaddefaults()
		vexcombo_energyTextbar = CreateFrame("Frame", nil, vexcombo_energybarbg)
		vexcombo_energybar = CreateFrame("Frame", nil, vexcombo_energybarbg)
		vexcombo_energybarDif = CreateFrame("Frame", nil, vexcombo_energybarbg)
		vexcombo_energytext_left = vexcombo_energyTextbar:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		vexcombo_energytext_right = vexcombo_energyTextbar:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		vexcombo_cpsbar_1 = CreateFrame("Frame", nil, vexcombo_energybarbg)
	end
	
	vexcombo_setMaxWidth()
	vexcombo_setCpsMax()
	
	--Energy Bar
	vexcombo_setEnergybarBG()
	vexcombo_setEnergybar()
	vexcombo_setEnergybarDif()
	vexcombo_setEnergyTextbar()
	vexcombo_setFontStrings()
	
	--ComboPoints
	vexcombo_setCpsBars()
	
	--Start
	vexcombo_setEnergyType()
	vexcombo_showEnergybars()
	vexcombo_changeEnergy()
end

function vexcombo_setMarkers()
	--Clear Markers
	for i=1,#vexcombo.markers do
		if vexcombo.markers[i] ~= nil then
			vexcombo.markers[i][1]:Hide()
		end
		vexcombo.markers[i]=nil
	end
	vexcombo.markers = {}
	
	--Set new markers
	local markers = vexcombo_parameters["frame"]["energy"]["markers"]["points"]
	for i,v in pairs(markers) do
		local temp = {}
		temp[1] = CreateFrame("Frame", nil, vexcombo_energyTextbar)
		temp[1]:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false,
							edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=vexcombo_parameters["frame"]["energy"]["markers"]["border"]["size"]})
		temp[1]:SetBackdropColor(vexcombo_parameters["frame"]["energy"]["markers"]["color"]["r"],
											vexcombo_parameters["frame"]["energy"]["markers"]["color"]["g"],
											vexcombo_parameters["frame"]["energy"]["markers"]["color"]["b"],
											vexcombo_parameters["frame"]["energy"]["markers"]["color"]["a"])
		temp[1]:SetBackdropBorderColor(vexcombo_parameters["frame"]["energy"]["markers"]["border"]["color"]["r"],
											vexcombo_parameters["frame"]["energy"]["markers"]["border"]["color"]["g"],
											vexcombo_parameters["frame"]["energy"]["markers"]["border"]["color"]["b"],
											vexcombo_parameters["frame"]["energy"]["markers"]["border"]["color"]["a"])
		temp[1]:SetWidth(vexcombo_parameters["frame"]["energy"]["markers"]["width"])
		temp[1]:SetHeight(vexcombo_parameters["frame"]["energy"]["size"]["height"]-(vexcombo_parameters["frame"]["energy"]["border"]["size"]*2)-4)
		temp[1]:SetPoint("TOPLEFT", vexcombo_energybarbg, "TOPLEFT", vexcombo_getEnergyWidth(v), -vexcombo_parameters["frame"]["energy"]["border"]["size"]-2)
		temp[1]:Show()
		temp[2]=v
		
		table.insert(vexcombo.markers,#vexcombo.markers+1, temp)
	end
end

function vexcombo_setMaxWidth()
	local newwidth = vexcombo_parameters["frame"]["energy"]["size"]["width"]-(vexcombo_parameters["frame"]["energy"]["border"]["size"]*2)
	if vexcombo.maxwidth ~= newwidth then
		vexcombo.maxwidth = newwidth
		vexcombo_setMarkers()
	end
end

function vexcombo_setEnergyMax()
	if UnitPowerMax("player") ~= vexcombo.maxenergy then
		vexcombo.maxenergy_prev = vexcombo.maxenergy
		vexcombo.maxenergy = UnitPowerMax("player")
		vexcombo_setMarkers()
	end
end

function vexcombo_setEnergyCurrent()
	local new = UnitPower("player")
	if new ~= vexcombo.currentenergy then
		vexcombo.currentenergy_prev = vexcombo.currentenergy
		vexcombo.currentenergy = new
	end
end

function vexcombo_getEnergyWidth(energy)
	local factor = energy / vexcombo.maxenergy
	local width = factor * vexcombo.maxwidth
	return width
end

function vexcombo_setCpsCurrent()
	local new = GetComboPoints("player")
	if new ~= vexcombo.currentcps then
		vexcombo.currentcps_prev = vexcombo.currentcps
		vexcombo.currentcps = new
	end
end

function vexcombo_setCpsMax()
	local class = select(2, UnitClass("player"))
	
	if class == "DEATHKNIGHT"	then vexcombo.maxcps = 6
	elseif class == "ROGUE"		then vexcombo.maxcps = 5
	elseif class == "PALADIN"	then vexcombo.maxcps = 3
	elseif class == "MONK"		then vexcombo.maxcps = 3
	elseif class == "DRUID"		then vexcombo.maxcps = 5
	else
		vexcombo.maxcps = 0
		print("Vex Combo: player class not supported for ComboPoints")
	end
	debugs.print(vexcombo.maxcps, "vexcombo.maxcps")
end

function vexcombo_changeCps()
	vexcombo_setCpsCurrent()
	print("vexcombo_changeCps")
end

function vexcombo_changeEnergy(energyTypeChanged)
	if vexcombo.show then
		if energyTypeChanged then vexcombo_energybar:SetWidth(vexcombo.maxwidth)
		else
			if not(vexcombo_energybar_anigrp:IsPlaying()) then
				vexcombo_setEnergyCurrent()
				vexcombo_setEnergyMax()
				vexcombo_changeEnergyText()
				
				local barfactor_current = vexcombo.currentenergy_prev/vexcombo.maxenergy
				local barfactor_new = vexcombo.currentenergy/vexcombo.maxenergy
				local barfactor = barfactor_new/barfactor_current
				
				local newWidth = vexcombo_getEnergyWidth(vexcombo.currentenergy)
				if barfactor < 1 then
					local oldWidth = vexcombo_getEnergyWidth(vexcombo.currentenergy_prev)
					local difWidth = oldWidth - newWidth
					
					vexcombo_energybar_ani:SetScale(barfactor, 1)
					vexcombo_energybar_anigrp:Play()
					
					vexcombo_energybarDif:SetWidth(difWidth)
					vexcombo_energybarDif:SetPoint("TOPLEFT", vexcombo_energybarbg, "TOPLEFT",
								vexcombo_parameters["frame"]["energy"]["border"]["size"]+newWidth,
								-vexcombo_parameters["frame"]["energy"]["border"]["size"])
					vexcombo_energybarDif_anigrp:Play()
					
				else 
					vexcombo_energybar:SetWidth(newWidth)
				end
			end
		end
	end
end

function vexcombo_changeEnergyText()
	local lefttemplate = vexcombo_parameters["frame"]["energy"]["text"]["left"]["text"]
	local righttemplate = vexcombo_parameters["frame"]["energy"]["text"]["right"]["text"]
	local percenergy = math.floor((vexcombo.currentenergy/vexcombo.maxenergy)*100)
	lefttemplate = string.gsub(lefttemplate, "{CurrentEnergy}", vexcombo.currentenergy)
	lefttemplate = string.gsub(lefttemplate, "{MaxEnergy}", vexcombo.maxenergy)
	lefttemplate = string.gsub(lefttemplate, "{PercEnergy}", ""..percenergy.."%%") -- %-function needs to be escaped with another %

	righttemplate = string.gsub(righttemplate, "{CurrentEnergy}", vexcombo.currentenergy)
	righttemplate = string.gsub(righttemplate, "{MaxEnergy}", vexcombo.maxenergy)
	righttemplate = string.gsub(righttemplate, "{PercEnergy}", ""..percenergy.."%%") -- %-function needs to be escaped with another %
	
	vexcombo_energytext_left:SetText(lefttemplate)
	vexcombo_energytext_right:SetText(righttemplate)
end

function vexcombo_setCpsBars()
	vexcombo_cpsbar_1:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false,
										edgeSize=vexcombo_parameters["frame"]["combo"]["border"]["size"]})
	vexcombo_cpsbar_1:SetBackdropColor(	vexcombo_parameters["frame"]["combo"]["bg"]["color"]["1"]["r"],
											vexcombo_parameters["frame"]["combo"]["bg"]["color"]["1"]["g"],
											vexcombo_parameters["frame"]["combo"]["bg"]["color"]["1"]["b"],
											vexcombo_parameters["frame"]["combo"]["bg"]["color"]["1"]["a"])
	vexcombo_cpsbar_1:SetBackdropBorderColor(	vexcombo_parameters["frame"]["combo"]["border"]["color"]["r"],
													vexcombo_parameters["frame"]["combo"]["border"]["color"]["g"],
													vexcombo_parameters["frame"]["combo"]["border"]["color"]["b"],
													vexcombo_parameters["frame"]["combo"]["border"]["color"]["a"])
	vexcombo_cpsbar_1:SetHeight(vexcombo_parameters["frame"]["combo"]["measure"]["height"])
	
	local offset_total = vexcombo_parameters["frame"]["combo"]["measure"]["offset"]*2
	local gap_total = (vexcombo.maxcps-1)*vexcombo_parameters["frame"]["combo"]["measure"]["gap"]
	local width = (vexcombo.maxwidth - gap_total - offset_total)/vexcombo.maxcps
	
	if vexcombo.maxcps>0 then
		vexcombo_cpsbar_1:SetWidth(width)
		vexcombo_cpsbar_1:SetPoint("TOPLEFT", vexcombo_energybarbg, "TOPLEFT",
							vexcombo_parameters["frame"]["combo"]["measure"]["offset"],
							vexcombo_parameters["frame"]["combo"]["measure"]["y"])
		vexcombo_cpsbar_1:Show() -- test only
	end
end

function vexcombo_setEnergybarBG()
	vexcombo_energybarbg:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false,
										edgeSize=vexcombo_parameters["frame"]["energy"]["border"]["size"]})
	vexcombo_energybarbg:SetBackdropColor(	vexcombo_parameters["frame"]["energy"]["bgcolor"]["r"],
											vexcombo_parameters["frame"]["energy"]["bgcolor"]["g"],
											vexcombo_parameters["frame"]["energy"]["bgcolor"]["b"],
											vexcombo_parameters["frame"]["energy"]["bgcolor"]["a"])
	vexcombo_energybarbg:SetBackdropBorderColor(	vexcombo_parameters["frame"]["energy"]["border"]["color"]["r"],
													vexcombo_parameters["frame"]["energy"]["border"]["color"]["g"],
													vexcombo_parameters["frame"]["energy"]["border"]["color"]["b"],
													vexcombo_parameters["frame"]["energy"]["border"]["color"]["a"])
	vexcombo_energybarbg:SetWidth(vexcombo_parameters["frame"]["energy"]["size"]["width"])
	vexcombo_energybarbg:SetHeight(vexcombo_parameters["frame"]["energy"]["size"]["height"])
	vexcombo_energybarbg:SetPoint("TOPLEFT", UIParent, "TOPLEFT", vexcombo_parameters["frame"]["energy"]["positon"]["x"], vexcombo_parameters["frame"]["energy"]["positon"]["y"])	
end

function vexcombo_setEnergybar()
	vexcombo_energybar:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false, edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=1})
	vexcombo_energybar:SetBackdropColor(	vexcombo_parameters["frame"]["energy"]["color"]["r"],
											vexcombo_parameters["frame"]["energy"]["color"]["g"],
											vexcombo_parameters["frame"]["energy"]["color"]["b"],
											vexcombo_parameters["frame"]["energy"]["color"]["a"])
	vexcombo_energybar:SetBackdropBorderColor(1,1,1,0)
	vexcombo_energybar:SetWidth(vexcombo.maxwidth)
	vexcombo_energybar:SetHeight(vexcombo_parameters["frame"]["energy"]["size"]["height"]-(vexcombo_parameters["frame"]["energy"]["border"]["size"]*2))
	vexcombo_energybar:SetPoint("TOPLEFT", vexcombo_energybarbg, "TOPLEFT",
						vexcombo_parameters["frame"]["energy"]["border"]["size"],
						-vexcombo_parameters["frame"]["energy"]["border"]["size"])
	vexcombo_energybar_anigrp = vexcombo_energybar:CreateAnimationGroup("vexcombo_energybar_anigrp")
	vexcombo_energybar_anigrp:SetLooping("NONE")
	vexcombo_energybar_ani = vexcombo_energybar_anigrp:CreateAnimation("Scale")
	vexcombo_energybar_ani:SetSmoothing("OUT")
	vexcombo_energybar_ani:SetDuration(0.2)
	vexcombo_energybar_ani:SetOrder(1)
	vexcombo_energybar_ani:SetOrigin("TOPLEFT",0,0)
end

function vexcombo_setEnergyTextbar()
	vexcombo_energyTextbar:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false, edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=1})
	vexcombo_energyTextbar:SetBackdropColor(0, 0, 0, 0)
	vexcombo_energyTextbar:SetBackdropBorderColor(1,1,1,0)
	vexcombo_energyTextbar:SetWidth(vexcombo.maxwidth)
	vexcombo_energyTextbar:SetHeight(vexcombo_parameters["frame"]["energy"]["size"]["height"]-(vexcombo_parameters["frame"]["energy"]["border"]["size"]*2))
	vexcombo_energyTextbar:SetPoint("TOPLEFT", vexcombo_energybarbg, "TOPLEFT",
						vexcombo_parameters["frame"]["energy"]["border"]["size"],
						-vexcombo_parameters["frame"]["energy"]["border"]["size"])
end

function vexcombo_setEnergybarDif()
	vexcombo_energybarDif:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false, edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=1})
	vexcombo_energybarDif:SetBackdropColor(1, 0.6, 0, 1)
	vexcombo_energybarDif:SetBackdropBorderColor(1,1,1,0)
	vexcombo_energybarDif:SetWidth(0)
	vexcombo_energybarDif:SetHeight(vexcombo_parameters["frame"]["energy"]["size"]["height"]-(vexcombo_parameters["frame"]["energy"]["border"]["size"]*2))
	vexcombo_energybarDif:SetPoint("TOPLEFT", vexcombo_energybarbg, "TOPLEFT",
						vexcombo_parameters["frame"]["energy"]["border"]["size"],
						-vexcombo_parameters["frame"]["energy"]["border"]["size"])
	vexcombo_energybarDif:Hide()
	vexcombo_energybarDif_anigrp = vexcombo_energybarDif:CreateAnimationGroup("vexcombo_energybarDif_anigrp")
	vexcombo_energybarDif_anigrp:SetLooping("NONE")
	vexcombo_energybarDif_anigrp:SetScript("OnPlay", function () vexcombo_energybarDif:Show() end)
	vexcombo_energybarDif_anigrp:SetScript("OnFinished", function () vexcombo_energybarDif:Hide() end)
	vexcombo_energybarDif_ani = vexcombo_energybarDif_anigrp:CreateAnimation("Alpha")
	vexcombo_energybarDif_ani:SetDuration(0.5)
	vexcombo_energybarDif_ani:SetOrder(1)
	vexcombo_energybarDif_ani:SetChange(-1)
end

function vexcombo_setFontStrings()
	-- FontString 1
	vexcombo_energytext_left:SetPoint("TOPLEFT", vexcombo_energyTextbar, "TOPLEFT" , vexcombo_parameters["frame"]["energy"]["text"]["left"]["x"], vexcombo_parameters["frame"]["energy"]["text"]["left"]["y"])
	vexcombo_energytext_left:SetTextColor(vexcombo_parameters["frame"]["energy"]["text"]["left"]["color"]["r"],
											vexcombo_parameters["frame"]["energy"]["text"]["left"]["color"]["g"],
											vexcombo_parameters["frame"]["energy"]["text"]["left"]["color"]["b"],
											vexcombo_parameters["frame"]["energy"]["text"]["left"]["color"]["a"])
	vexcombo_energytext_left:SetText(vexcombo.currentenergy)
	vexcombo_energytext_left:SetFont(vexcombo_parameters["frame"]["energy"]["text"]["left"]["font"], vexcombo_parameters["frame"]["energy"]["text"]["left"]["size"])	
	vexcombo_energytext_left:SetWidth(vexcombo_parameters["frame"]["energy"]["text"]["left"]["width"])	
	vexcombo_energytext_left:SetJustifyH(vexcombo_parameters["frame"]["energy"]["text"]["left"]["align"])
	
	-- FontString 2
	vexcombo_energytext_right:SetPoint("TOPRIGHT", vexcombo_energyTextbar, "TOPRIGHT" , vexcombo_parameters["frame"]["energy"]["text"]["right"]["x"], vexcombo_parameters["frame"]["energy"]["text"]["right"]["y"])
	vexcombo_energytext_right:SetTextColor(vexcombo_parameters["frame"]["energy"]["text"]["right"]["color"]["r"],
											vexcombo_parameters["frame"]["energy"]["text"]["right"]["color"]["g"],
											vexcombo_parameters["frame"]["energy"]["text"]["right"]["color"]["b"],
											vexcombo_parameters["frame"]["energy"]["text"]["right"]["color"]["a"])
	vexcombo_energytext_right:SetText(vexcombo.maxenergy)	
	vexcombo_energytext_right:SetFont(vexcombo_parameters["frame"]["energy"]["text"]["right"]["font"], vexcombo_parameters["frame"]["energy"]["text"]["right"]["size"])	
	vexcombo_energytext_right:SetWidth(vexcombo_parameters["frame"]["energy"]["text"]["right"]["width"])	
	vexcombo_energytext_right:SetJustifyH(vexcombo_parameters["frame"]["energy"]["text"]["right"]["align"])
end

function vexcombo_showEnergybars()
	local show = true
	--check for enabled addon
	if vexcombo_parameters["frame"]["energy"]["show"] then
		--check for infight
		if vexcombo_parameters["frame"]["infightshow"] and vexcombo.infight	then show = true
		elseif not(vexcombo_parameters["frame"]["infightshow"])				then show = true
		else show = false end
	else show = false end
	
	--check for show not with manapool
	if not(vexcombo_parameters["frame"]["energy"]["showwithmana"]) and vexcombo.energytype == "MANA" then show = false end
	
	--react to 'show'
	vexcombo.show = show
		
	if show then 	vexcombo_energybarbg:Show() 
	else			vexcombo_energybarbg:Hide() end
end







